//#define _GLIBCXX_DEBUG
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx")
#include <bits/stdc++.h>
//#define int long long
#define endl '\n'
using namespace std;
vector<int> g[100001];
int n;
stack<int> mp;
//map<pair<int,int>,bool>memo;
//bool is_tl(){
//    double time=(1.0*clock()/CLOCKS_PER_SEC);
//    return time>=0.985;
//}
bool used[100001];
void dfs(int v){
  //  if(is_tl()){
  //      puts("NO");
  //      exit(0);
  //  }
    used[v]=true;
    mp.push(v);
    for(auto i:g[v]){
        if(!used[i]){
            dfs(i);
        }
        if(i==1&& mp.size()==n){
                mp.push(1);
                puts(("YES"));
                while(!mp.empty()){
                    printf("%d ",mp.top());
                    mp.pop();
                }
                exit(0);
        }
    }
    mp.pop();
    used[v]=false;
    return;
}
void Bogdan(){
    //const time_t timer=time(NULL);
    int m;
    scanf("%d %d",&n,&m);
    int l,r;
    for(int i=0;i<m;i++){
        scanf("%d %d",&l,&r);
        g[r].push_back(l);
    }
    for(int i=1;i<=n;i++){
        if(!g[i].size()){
           puts("NO\n");
            return;
        }
    }
    dfs(1);
    puts(("NO"));
    return;
}
/*
*/
main(){
    int t=1,n;
   // cin>>t;
    while(t--){
        Bogdan();
    }
}
